//
//  SBBackGroundScene.m
//  SBGame
//
//  Created by Xiaoxuan Tang on 13-1-1.
//
//

#import "SBBackGroundScene.h"
#import "SBCinematicFirst.h"
@implementation SBBackGroundScene

- (id) init
{
    if ( self = [super init] )
    {
        [[CCSpriteFrameCache sharedSpriteFrameCache] addSpriteFramesWithFile:@"SBBackground.plist"];
        _nowIndex = 0;
        [self schedule:@selector(tick) interval:2];
        [self runAction:[CCSequence actionOne:[CCDelayTime actionWithDuration:65]
                                          two:[CCCallFuncN actionWithTarget:self
                                                                   selector:@selector(nextScene)]]];
    }
    return self;
}

- (void) nextScene
{
    [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:.5
                                                                                 scene:[SBCinematicFirst node]]];
}

- (void) tick
{
    _nowIndex++;
    CGSize winSize = [CCDirector sharedDirector].winSize;
    CCSprite* sprite = [CCSprite spriteWithSpriteFrameName:[NSString stringWithFormat:@"%d.png", _nowIndex]];
    sprite.position = ccp(winSize.width/2, 0);
    sprite.anchorPoint = ccp(.5, 1);
    CCMoveBy* move = [CCMoveBy actionWithDuration:30 position:ccp(0, winSize.height+30)];
    CCScaleTo* scale = [CCScaleTo actionWithDuration:30 scaleX:.3 scaleY:.5];
    [sprite runAction:[CCSequence actions:[CCSpawn actionOne:[CCEaseIn actionWithAction:move rate:.8] two:scale], [CCFadeOut actionWithDuration:.5], nil]];
    [self addChild:sprite];
    
    if (_nowIndex == 21)
        [self unschedule:_cmd];
}
@end
