//
//  SBCinematicFifth.m
//  SBGame
//
//  Created by Xiaoxuan Tang on 13-1-2.
//
//

#import "SBCinematicFifth.h"

@implementation SBCinematicFifth

- (id) init
{
    if (self = [super init])
    {
        CGSize winSize = [CCDirector sharedDirector].winSize;
        
        if (winSize.width < winSize.height )
        {
            CGFloat tmp = winSize.height;
            winSize.height= winSize.width;
            winSize.width = tmp;
        }
        
        CCLayerColor* blackMB = [CCLayerColor layerWithColor:ccc4(0, 0, 0, 255)
                                                       width:winSize.width
                                                      height:winSize.height];
        blackMB.position = ccp(0, 0);
        blackMB.anchorPoint = ccp(.5, .5);
        blackMB.tag = 1;
        [self addChild:blackMB z:1024];
        
        CCLabelTTF* MBLabel = [CCLabelTTF labelWithString:@"Chapter 2"
                                                 fontName:@"Zapfino"
                                                 fontSize:50];
        MBLabel.position = ccp(winSize.width/2, winSize.height/2+60);
        MBLabel.anchorPoint = ccp(.5, .5);
        [blackMB addChild:MBLabel];
        
        MBLabel = [CCLabelTTF labelWithString:@"East Palace"
                                     fontName:@"Zapfino"
                                     fontSize:50];
        MBLabel.position = ccp(winSize.width/2, winSize.height/2-60);
        [blackMB addChild:MBLabel];
        
        [blackMB runAction:[CCSequence actions:[CCDelayTime actionWithDuration:2], [CCFadeOut actionWithDuration:1.5], [CCCallBlockN actionWithBlock:^(CCNode *node) {
            [node removeFromParentAndCleanup:YES];
        }], nil]];
        
        
        [blackMB runAction:[CCSequence actions:[CCDelayTime actionWithDuration:2], [CCFadeOut actionWithDuration:1.5], [CCCallBlockN actionWithBlock:^(CCNode *node) {
            [node removeFromParentAndCleanup:YES];
        }], nil]];
        
        CCLayer* talkLayer = [CCLayer node];
        talkLayer.tag = 2;
        talkLayer.position = ccp(0, 0);
        CCSprite* backGround = [CCSprite spriteWithFile:@"Second-Chapter.png"];
        backGround.anchorPoint = ccp(0, 0);
        backGround.position = ccp(0, 0);
        [talkLayer addChild:backGround];
        [self addChild:talkLayer z:0];
        
        CCLabelTTF* talk = [CCLabelTTF labelWithString:@"You guys want to borrow DragonBall? Do you know the importance of the DragonBall to the Dragon?"
                                            dimensions:CGSizeMake(370, 200)
                                            hAlignment:kCCTextAlignmentLeft
                                              fontName:@"Helvetica"
                                              fontSize:25];
        
        talk.color = ccc3(0, 0, 0);
        talk.position = ccp(125, 540);
        talk.anchorPoint = ccp(0, 1);
        talk.opacity = 0;
        talk.tag = 1;
        
        [talk runAction:[CCSequence actionOne:[CCSequence actionOne:[CCDelayTime actionWithDuration: 3.5]
                                                                two:[CCCallFunc actionWithTarget:self
                                                                                        selector:@selector(addTouchTargetedDelegate)]]
                                          two:[CCFadeIn actionWithDuration:1]]];
        [talkLayer addChild:talk];
        
        _touchCnt = 0;
    }
    return self;
}

- (void) addTouchTargetedDelegate
{
    [[CCDirector sharedDirector].touchDispatcher addTargetedDelegate:self
                                                            priority:0
                                                     swallowsTouches:YES];
    
}

- (BOOL)ccTouchBegan:(UITouch *)touch withEvent:(UIEvent *)event
{
    if (_touchCnt == 0)
    {
        _touchCnt ++;
        CCSprite* node = (CCSprite*)[[self getChildByTag:2] getChildByTag:1];
        [node stopAllActions];
        node.opacity = 1;
        
        CCLabelTTF* talk = [CCLabelTTF labelWithString:@"Yes. Our little sister is badly ill now. We have no way to save her, so we need Dragon's help."
                                            dimensions:CGSizeMake(370, 200)
                                            hAlignment:kCCTextAlignmentLeft
                                              fontName:@"Helvetica"
                                              fontSize:25];
        talk.color = ccc3(0, 0, 0);
        talk.position = ccp(620, 390);
        talk.anchorPoint = ccp(0, 1);
        talk.opacity = 0;
        talk.tag = 2;
        [talk runAction:[CCFadeIn actionWithDuration:1]];
        [[self getChildByTag:2] addChild:talk];
        
        return NO;
    }
    
    if (_touchCnt == 1)
    {
        _touchCnt ++;
        
        CCSprite* node = (CCSprite*)[[self getChildByTag:2] getChildByTag:2];
        [node stopAllActions];
        node.opacity = 1;
        
        CCLabelTTF* talk = (CCLabelTTF*) [[self getChildByTag:2] getChildByTag:1];
        talk.opacity = 0;
        talk.string = @"Why would I help you?";
        [talk runAction:[CCFadeIn actionWithDuration:1]];
        
        return NO;
    }
    
    if (_touchCnt == 2)
    {
        _touchCnt ++;
        
        CCSprite* node = (CCSprite* )[[self getChildByTag:2] getChildByTag:1];
        [node stopAllActions];
        node.opacity = 1;
        
        CCLabelTTF* talk = [CCLabelTTF labelWithString:@"My Lord, I have heard there exists a God Animal called BianNiu recently. But it was caught by the Water Tribe. "
                                            dimensions:CGSizeMake(370, 200)
                                            hAlignment:kCCTextAlignmentLeft
                                              fontName:@"Helvetica"
                                              fontSize:25];
        talk.color = ccc3(0, 0, 0);
        talk.position = ccp(120, 180);
        talk.anchorPoint = ccp(0, 1);
        talk.opacity = 0;
        talk.tag = 3;
        [talk runAction:[CCFadeIn actionWithDuration:1]];
        [[self getChildByTag:2] addChild:talk];
        
        return NO;
    }
    
    if (_touchCnt == 3)
    {
        _touchCnt ++;
        
        CCLabelTTF* talk = (CCLabelTTF*) [[self getChildByTag:2] getChildByTag:3];
        [talk stopAllActions];
        
        talk.opacity = 0;
        talk.string = @"Why not let them try to save BianNiu for us as a condition?";
        [talk runAction:[CCFadeIn actionWithDuration:1]];
        
        return NO;
    }
    
    if (_touchCnt == 4)
    {
        _touchCnt ++;
        
        CCSprite* node = (CCSprite*)[[self getChildByTag:2] getChildByTag:3];
        [node stopAllActions];
        node.opacity = 1;
        
        CCLabelTTF* talk = (CCLabelTTF*) [[self getChildByTag:2] getChildByTag:1];
        talk.string = @"Right. If you can defeat the Water army, I'll help you.";
        talk.opacity = 0;
        [talk runAction:[CCFadeIn actionWithDuration:1]];
        
        return NO;
    }
    
    if (_touchCnt == 5)
    {
        _touchCnt ++;
        
        CCSprite* node = (CCSprite*)[[self getChildByTag:2] getChildByTag:1];
        [node stopAllActions];
        node.opacity = 1;
        
        CCLabelTTF* talk = (CCLabelTTF*) [[self getChildByTag:2] getChildByTag:2];
        talk.string = @"Deal.";
        talk.opacity = 0;
        [talk runAction:[CCSequence actionOne:[CCFadeIn actionWithDuration:1]
                                           two:[CCCallFuncN actionWithTarget:self selector:@selector(nextScene)]]];;
        [[CCDirector sharedDirector].touchDispatcher removeDelegate:self];
        return NO;
    }
    return NO;
}

- (void) nextScene
{
    
}
@end
