//
//  SBCinematicSecond.m
//  SBGame
//
//  Created by Xiaoxuan Tang on 13-1-2.
//
//

#import "SBCinematicSecond.h"
#import "SBToBeContinue.h"
#import "SBGlobal.h"
#import "SimpleAudioEngine.h"
@implementation SBCinematicSecond

- (id) init
{
    if ( self = [super init])
    {
        if (![[SimpleAudioEngine sharedEngine] isBackgroundMusicPlaying])
        {
            
            [[SimpleAudioEngine sharedEngine] playBackgroundMusic:@"bgm.mp3" loop:YES];
            [SBGlobal sharedGlobal].bgmName = @"bgm.mp3";
        }
        else
            if (![[SBGlobal sharedGlobal].bgmName isEqualToString:@"bgm.mp3"])
            {
                [[SimpleAudioEngine sharedEngine] playBackgroundMusic:@"bgm.mp3" loop:YES];
                [SBGlobal sharedGlobal].bgmName = @"bgm.mp3";
            }
        
        CGSize winSize = [CCDirector sharedDirector].winSize;
        
        if (winSize.width < winSize.height )
        {
            CGFloat tmp = winSize.height;
            winSize.height= winSize.width;
            winSize.width = tmp;
        }
        
        CCLayerColor* blackMB = [CCLayerColor layerWithColor:ccc4(0, 0, 0, 255)
                                                       width:winSize.width
                                                      height:winSize.height];
        blackMB.position = ccp(0, 0);
        blackMB.anchorPoint = ccp(.5, .5);
        blackMB.tag = 1;
        [self addChild:blackMB z:1024];
        
        CCLabelTTF* MBLabel = [CCLabelTTF labelWithString:@"Interlude"
                                                 fontName:@"Zapfino"
                                                 fontSize:50];
        MBLabel.position = ccp(winSize.width/2, winSize.height/2);
        MBLabel.anchorPoint = ccp(.5, .5);
        [blackMB addChild:MBLabel];
        
        [blackMB runAction:[CCSequence actions:[CCDelayTime actionWithDuration:2], [CCFadeOut actionWithDuration:1.5], [CCCallBlockN actionWithBlock:^(CCNode *node) {
            [node removeFromParentAndCleanup:YES];
        }], nil]];
        
        CCLayer* talkLayer = [CCLayer node];
        talkLayer.tag = 2;
        talkLayer.position = ccp(0, 0);
        CCSprite* backGround = [CCSprite spriteWithFile:@"First-Chapter.png"];
        backGround.anchorPoint = ccp(0, 0);
        backGround.position = ccp(0, 0);
        [talkLayer addChild:backGround];
        [self addChild:talkLayer z:0];
        
        CCLabelTTF* talk = [CCLabelTTF labelWithString:@"The enemy is too powerful, we have to retreat temporarily"
                                            dimensions:CGSizeMake(380, 200)
                                            hAlignment:kCCTextAlignmentLeft
                                              fontName:@"Helvetica"
                                              fontSize:25];
        
        talk.color = ccc3(0, 0, 0);
        talk.position = ccp(120, 500);
        talk.anchorPoint = ccp(0, 1);
        talk.opacity = 0;
        talk.tag = 1;
        [talk runAction:[CCSequence actionOne:[CCSequence actionOne:[CCDelayTime actionWithDuration: 3.5]
                                                                two:[CCCallFunc actionWithTarget:self
                                                                                        selector:@selector(addTouchTargetedDelegate)]]
                                          two:[CCFadeIn actionWithDuration:1]]];
        [talkLayer addChild:talk];
        
        _touchCnt = 0;
    }
    return self;
}

- (void) addTouchTargetedDelegate
{
    [[CCDirector sharedDirector].touchDispatcher addTargetedDelegate:self
                                                            priority:0
                                                     swallowsTouches:YES];

}

- (BOOL)ccTouchBegan:(UITouch *)touch withEvent:(UIEvent *)event
{
    if (_touchCnt == 0)
    {
        CCLabelTTF* label = (CCLabelTTF*) [[self getChildByTag:2] getChildByTag:1];
        [label stopAllActions];
        label.opacity = 1;
        
        CCLabelTTF* talk = [CCLabelTTF labelWithString:@"But..."
                                            dimensions:CGSizeMake(370, 200)
                                            hAlignment:kCCTextAlignmentLeft
                                              fontName:@"Helvetica"
                                              fontSize:25];
        
        talk.color = ccc3(0, 0, 0);
        talk.position = ccp(590, 190);
        talk.anchorPoint = ccp(0, 1);
        talk.opacity = 0;
        talk.tag = 2;
        [talk runAction:[CCFadeIn actionWithDuration:1]];
        [[self getChildByTag:2] addChild:talk];
        _touchCnt ++;
        return NO;
    }
    
    if (_touchCnt == 1)
    {
        CCLabelTTF* label = (CCLabelTTF*) [[self getChildByTag:2] getChildByTag:2];
        [label stopAllActions];
        label.opacity = 1;
        
        label = (CCLabelTTF*) [[self getChildByTag:2] getChildByTag:1];
        label.opacity = 0;
        label.string = @"It's not a withdraw, but now the most importance for us is the TIME. We'll be back, I promise!";
        [label runAction:[CCSequence actionOne:[CCFadeIn actionWithDuration:1]
                                          two:[CCCallFuncN actionWithTarget:self selector:@selector(nextScene)]]];;
        [[CCDirector sharedDirector].touchDispatcher removeDelegate:self];
        _touchCnt ++;
    }
    return NO;
}

- (void) nextScene
{
    [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:.5f scene:[SBToBeContinue node]]];
}

@end
