//
//  SBGameLayer.m
//  SBGame
//
//  Created by Xiaoxuan Tang on 12-11-23.
//
//

#import "SBGameLayer.h"
#import "cocos2d.h"
#import "SBSprite.h"

@implementation SBGameLayer

- (id) initWithLevel:(NSInteger)level
{
    if (self = [super init])
    {
        CGSize winSize = [CCDirector sharedDirector].winSize;
        if (winSize.height > winSize.width)
        {
            CGFloat tmp = winSize.width;
            winSize.width = winSize.height;
            winSize.height = tmp;
        }
        
        
        CCSprite* backGround = [CCSprite spriteWithFile:@"gamebg.png"];
        backGround.position = ccp(0, 0);
        backGround.anchorPoint = ccp(0, 0);
        [self addChild:backGround];
        
        [[CCDirector sharedDirector].touchDispatcher addTargetedDelegate:self
                                                                priority:0
                                                         swallowsTouches:YES];
    }
    return self;
}

- (BOOL) ccTouchBegan:(UITouch *)touch withEvent:(UIEvent *)event
{
    _firstTouchPoint = [touch locationInView:[touch view]];
    _firstTouchPoint = [[CCDirector sharedDirector] convertToGL:_firstTouchPoint];
    return YES;
}

- (void) ccTouchMoved:(UITouch *)touch withEvent:(UIEvent *)event
{
    CGPoint point = [touch locationInView:[touch view]];
    point = [[CCDirector sharedDirector] convertToGL:point];
    
    CGPoint newPosition = ccpAdd(self.position, ccp((point.x-_firstTouchPoint.x), 0));
    if (newPosition.x > 1024-2458 && newPosition.x <= 0)
    {
        self.position = newPosition;
    }
    _firstTouchPoint = point;
}

- (void) ccTouchEnded:(UITouch *)touch withEvent:(UIEvent *)event
{
    
}

- (void) dealloc
{
    [[CCDirector sharedDirector].touchDispatcher removeDelegate:self];
    [super dealloc];
}
@end
