//
//  SBGameSelectScene.m
//  SBGame
//
//  Created by Xiaoxuan Tang on 12-11-23.
//
//

#import "SBGameSelectScene.h"
#import "SBGlobal.h"
#import "SimpleAudioEngine.h"
#import "SBGameScene.h"
@implementation SBGameSelectScene

- (void) btnClicked: (CCMenuItemImage*) sender
{
    sender.color = ccGRAY;
    [(CCLabelTTF*)[sender getChildByTag:1] setColor:ccGRAY];
    [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:.3 scene:[SBGameScene node]]];
}

- (id) init
{
    if ( self = [super init] )
    {
        if (![[SimpleAudioEngine sharedEngine] isBackgroundMusicPlaying])
        {
            [[SimpleAudioEngine sharedEngine] playBackgroundMusic:@"bgm.mp3" loop:YES];
            [SBGlobal sharedGlobal].bgmName = @"bgm.mp3";
        }
        else
            if (![[SBGlobal sharedGlobal].bgmName isEqualToString:@"bgm.mp3"])
            {
                [[SimpleAudioEngine sharedEngine] playBackgroundMusic:@"bgm.mp3" loop:YES];
                [SBGlobal sharedGlobal].bgmName = @"bgm.mp3";
            }
        
        
        CGSize winSize = [CCDirector sharedDirector].winSize;
        if (winSize.height > winSize.width)
        {
            CGFloat tmp = winSize.width;
            winSize.width = winSize.height;
            winSize.height = tmp;
        }
        
        CCSprite* backGround = [CCSprite spriteWithFile:@"62-1.png"];
        backGround.scaleX = winSize.width/backGround.boundingBox.size.width;
        backGround.scaleY = winSize.height / backGround.boundingBox.size.height;
        backGround.position = ccp(0, 0);
        backGround.anchorPoint = ccp(0, 0);
        [self addChild:backGround];
        
        CCMenu* menu = [CCMenu menuWithItems: nil];
        NSInteger visible = [SBGlobal sharedGlobal].visible;
        for (int i=0; i<15; i++) {
            CCMenuItemImage* image;
            if (i > visible)
            {
                image = [CCMenuItemImage itemWithNormalImage:@"lock.png"
                                               selectedImage:@"lock.png"
                                                      target:self
                                                    selector:@selector(btnClicked:)];
            }
            else
            {
                image = [CCMenuItemImage itemWithNormalImage:@"normal.png"
                                               selectedImage:@"normal.png"
                                                      target:self
                                                    selector:@selector(btnClicked:)];
                CCLabelTTF* label = [CCLabelTTF labelWithString:[NSString stringWithFormat:@"%d", i+1]
                                                       fontName:@"Marker Felt"
                                                       fontSize:100];
                label.position = ccp(image.boundingBox.size.width/2, image.boundingBox.size.height/2+20);
                label.tag = 1;
                [image addChild:label];
            }

            image.scale = .5f;
            image.tag = i;
            image.position = ccp(winSize.width* (i%5+1)/6, winSize.height * (4-(i / 5))/5);
            [menu addChild:image];
        }
        menu.position = ccp(0, 0);
    [self addChild:menu];
    }
    return self;
}

@end
