//
//  SBGlobal.m
//  SBGame
//
//  Created by Xiaoxuan Tang on 12-11-22.
//
//

#import "SBGlobal.h"
#import "SimpleAudioEngine.h"
#import "CCSlider.h"
static SBGlobal* _sharedGlobal = nil;

@implementation SBGlobal

- (void) setBgmVolume:(CGFloat)bgmVolume
{
    _bgmVolume = [SimpleAudioEngine sharedEngine].backgroundMusicVolume = bgmVolume;
}

- (void) setEffectVolume:(CGFloat)effectVolume
{
    _effectVolume = [SimpleAudioEngine sharedEngine].effectsVolume = effectVolume;
}

+ (SBGlobal*) sharedGlobal
{
    if (_sharedGlobal == nil)
    {
        _sharedGlobal = [[SBGlobal alloc] init];
    }
    
    return _sharedGlobal;
}


- (id) init
{
    if ( self = [super init] )
    {
        NSString* path = [NSHomeDirectory() stringByAppendingString:@"/config.plist"];
        if (![[NSFileManager defaultManager] fileExistsAtPath:@"config.plist"])
        {
            _bgmVolume = [SimpleAudioEngine sharedEngine].backgroundMusicVolume;
            _effectVolume = [SimpleAudioEngine sharedEngine].effectsVolume;
        }
        else{
            NSDictionary* dict = [NSDictionary dictionaryWithContentsOfFile:path];
            [SimpleAudioEngine sharedEngine].backgroundMusicVolume = _bgmVolume = [dict[@"bgm"] floatValue];
            [SimpleAudioEngine sharedEngine].effectsVolume = _effectVolume = [dict[@"effect"] floatValue];
        }
        
        
        _visible = 0;
    }
    return self;
}

- (void) dealloc
{
    [_bgmName release];
    [super dealloc];
}
@end
