//
//  SBMenuLayer.m
//  SBGame
//
//  Created by Xiaoxuan Tang on 13-1-3.
//
//

#import "SBMenuLayer.h"
#import "SBGlobal.h"
@implementation SBMenuLayer

- (id) initWithLevel:(NSInteger) level
{
    if (self = [super init] )
    {
        _level = level;
        CCSprite* coinBackground = [CCSprite spriteWithFile:@"coin.png"];
        coinBackground.anchorPoint = ccp(0, 1);
        coinBackground.position = ccp(40, 120);
        [self addChild:coinBackground];
        
        moneyLabel = [CCLabelTTF labelWithString:[NSString stringWithFormat:@"%d", [SBGlobal sharedGlobal].money]
                                        fontName:@"Helvetica"
                                        fontSize:30];
        moneyLabel.color = ccc3(0, 0, 0);
        moneyLabel.anchorPoint = ccp(1, .5);
        moneyLabel.position = ccp(285, 42);
        [coinBackground addChild:moneyLabel];
        
        CCMenu* menu = [CCMenu menuWithItems: nil];
        menu.position = ccp(0, 0);
        
        
        CCMenuItemImage* menuButton = [CCMenuItemImage itemWithNormalImage:@"menuBtn.png"
                                                             selectedImage:@"menuBtn.png"
                                                                    target:self
                                                                  selector:@selector(menuBtnClick)];
        menuButton.position = ccp(705, 685);
        menuButton.anchorPoint = ccp(0, 0);
        [menu addChild:menuButton];
        
        popLayer = [[SBMenuPopLayer alloc] init];
        popLayer.position = ccp(0, 0);
        [self addChild:popLayer];
        [popLayer release];
        popLayer.visible = NO;
        
        if (level == 1)
        {
            CCSprite* level = [CCSprite spriteWithFile:@"level1.png"];
            level.position = ccp(380, 30);
            level.anchorPoint = ccp(0, 0);
            [self addChild:level];
            
            CCMenuItemImage* majorBtn = [CCMenuItemImage itemWithNormalImage:@"majorBtn.png"
                                                               selectedImage:@"majorBtn.png"
                                                                      target:self
                                                                    selector:@selector(addSprite:)];
            majorBtn.anchorPoint = ccp(0, 0);
            majorBtn.position = ccp(60, 570);
            majorBtn.tag = 1;
            [menu addChild:majorBtn];
            
            CCMenuItemImage* cyBtn = [CCMenuItemImage itemWithNormalImage:@"cyBtn.png"
                                                            selectedImage:@"cyBtn.png"
                                                                   target:self
                                                                 selector:@selector(addSprite:)];
            cyBtn.anchorPoint = ccp(0, 0);
            cyBtn.position = ccp(200, 570);
            cyBtn.tag = 2;
            [menu addChild:cyBtn];
            
            CCMenuItemImage* fireBtn = [CCMenuItemImage itemWithNormalImage:@"fireBtn.png"
                                                              selectedImage:@"fireBtn.png"
                                                                     target:self
                                                                   selector:@selector(addSprite:)];
            fireBtn.anchorPoint = ccp(0, 0);
            fireBtn.position = ccp(70, 490);
            fireBtn.tag = 3;
            [menu addChild:fireBtn];
            
            CCMenuItemImage* waterBtn =[CCMenuItemImage itemWithNormalImage:@"waterBtn.png"
                                                              selectedImage:@"waterBtn.png"
                                                                     target:self
                                                                   selector:@selector(addSprite:)];
            waterBtn.anchorPoint = ccp(0, 0);
            waterBtn.position = ccp(170, 490);
            waterBtn.tag = 4;
            [menu addChild:waterBtn];
            
            CCMenuItemImage* sandBtn = [CCMenuItemImage itemWithNormalImage:@"sandBtn.png"
                                                              selectedImage:@"sandBtn.png"
                                                                     target:self
                                                                   selector:@selector(addSprite:)];
            sandBtn.anchorPoint = ccp(0, 0);
            sandBtn.position = ccp(265, 490);
            sandBtn.tag = 5;
            [menu addChild:sandBtn];
        }
        
        [self addChild:menu];
    }
    return self;
}

- (void) alertEarnMoney
{
    UIAlertView* alert = [[UIAlertView alloc] initWithTitle:nil
                                                    message:@"You don't have enough money"
                                                   delegate:nil
                                          cancelButtonTitle:@"OK"
                                          otherButtonTitles: nil];
    [alert show];
    [alert release];
}

- (void) addSprite:(CCMenuItemImage*) sender
{
    if (_level == 1)
    {
        switch (sender.tag) {
            case 1:
                if ([SBGlobal sharedGlobal].money >= 120)
                {
                    [SBGlobal sharedGlobal].money -= 120;
                    [self moneyChange];
                    [[NSNotificationCenter defaultCenter] postNotificationName:@"addSprite" object:nil userInfo:@{@"type":@"major"}];
                }
                else
                {
                    [self alertEarnMoney];
                }
                
                break;
            case 2:
                if ([SBGlobal sharedGlobal].money >= 110)
                {
                    [SBGlobal sharedGlobal].money -= 110;
                    [self moneyChange];
                    [[NSNotificationCenter defaultCenter] postNotificationName:@"addSprite" object:nil userInfo:@{@"type":@"cy"}];
                }
                else
                {
                    [self alertEarnMoney];
                }
                
                break;
            case 3:
                if ([SBGlobal sharedGlobal].money >= 20)
                {
                    [SBGlobal sharedGlobal].money -= 20;
                    [self moneyChange];
                    [[NSNotificationCenter defaultCenter] postNotificationName:@"addSprite" object:nil userInfo:@{@"type":@"fire"}];
                }
                else
                {
                    [self alertEarnMoney];
                }
                break;
            case 4:
                if ([SBGlobal sharedGlobal].money >= 15)
                {
                    [SBGlobal sharedGlobal].money -= 15;
                    [self moneyChange];
                    [[NSNotificationCenter defaultCenter] postNotificationName:@"addSprite" object:nil userInfo:@{@"type":@"water"}];
                }
                else
                {
                    [self alertEarnMoney];
                }
                break;
            case 5:
                if ([SBGlobal sharedGlobal].money >= 18)
                {
                    [SBGlobal sharedGlobal].money -= 18;
                    [self moneyChange];
                    [[NSNotificationCenter defaultCenter] postNotificationName:@"addSprite" object:nil userInfo:@{@"type":@"sand"}];
                }
                else
                {
                    [self alertEarnMoney];
                }
                break;                
            default:
                break;
        }
    
    }
}

- (void) moneyChange
{
    moneyLabel.string = [NSString stringWithFormat:@"%d", [SBGlobal sharedGlobal].money];
}

- (void) menuBtnClick
{
//    [[CCDirector sharedDirector] pause];  
    popLayer.visible = YES;
}
@end
