//
//  SBMenuPopLayer.m
//  SBGame
//
//  Created by Xiaoxuan Tang on 13-1-3.
//
//

#import "SBMenuPopLayer.h"

@implementation SBMenuPopLayer

- (id) init
{
    if ( self = [super init])
    {
        CCSprite* backGround = [CCSprite spriteWithFile:@"popMenuBackground.png"];
        backGround.position = ccp(720, 665);
        backGround.anchorPoint = ccp(0, 1);
        [self addChild:backGround];
        
        continueBtn = [CCMenuItemImage itemWithNormalImage:@"continueBtn.png"
                                             selectedImage:@"continueBtn.png"
                                                    target:self
                                                  selector:@selector(continueBtnClick)];
        continueBtn.position = ccp(788, 608);
        continueBtn.anchorPoint = ccp(0, 1);
        
        saveBtn = [CCMenuItemImage itemWithNormalImage:@"saveBtn.png"
                                         selectedImage:@"saveBtn.png"
                                                target:self
                                              selector:@selector(saveBtnClick)];
        saveBtn.position = ccp(788, 550);
        saveBtn.anchorPoint = ccp(0, 1);
        
        settingBtn = [CCMenuItemImage itemWithNormalImage:@"settingBtn.png"
                                            selectedImage:@"settingBtn.png"
                                                   target:self
                                                 selector:@selector(settingBtnClick)];
        settingBtn.position = ccp(788, 500);
        settingBtn.anchorPoint = ccp(0, 1);
        
        exitBtn = [CCMenuItemImage itemWithNormalImage:@"exitBtn.png"
                                                    selectedImage:@"exitBtn.png"
                                                target:self
                                              selector:@selector(exitBtnClick)];
        exitBtn.position = ccp(788, 440);
        exitBtn.anchorPoint = ccp(0, 1);
        
        yesBtn = [CCMenuItemImage itemWithNormalImage:@"button_Y.png"
                                        selectedImage:@"button_Y2.png"
                                               target:self
                                             selector:@selector(yesBtnClick)];
        yesBtn.position = ccp(750, 360);
        yesBtn.anchorPoint  = ccp(0, 1);
        yesBtn.visible = NO;
        
        noBtn = [CCMenuItemImage itemWithNormalImage:@"button_N.png"
                                       selectedImage:@"button_N2.png"
                                              target:self
                                            selector:@selector(noBtnClick)];
        noBtn.position = ccp(900, 360);
        noBtn.anchorPoint = ccp(0, 1);
        noBtn.visible = NO;
        
        CCMenu * menu = [CCMenu menuWithItems:continueBtn, saveBtn, settingBtn, exitBtn, yesBtn, noBtn,nil];
        menu.position = ccp(0, 0);
        [self addChild:menu];
        
//        [[CCDirector sharedDirector].touchDispatcher addTargetedDelegate:self priority:-128 swallowsTouches:YES];
    }
    return self;
}

- (void) continueBtnClick
{
    [[NSNotificationCenter defaultCenter] postNotificationName:@"gameResume"
                                                        object:nil
                                                      userInfo:nil];
    self.visible = NO;
}

- (void) saveBtnClick
{
    [[NSNotificationCenter defaultCenter] postNotificationName:@"gameSave"
                                                        object:nil
                                                      userInfo:nil];
    self.visible = NO;
}

- (void) settingBtnClick
{
    
}

- (void) exitBtnClick
{
    [self showYesAndNo:YES];
}

- (void) yesBtnClick
{
    [[NSNotificationCenter defaultCenter] postNotificationName:@"gameQuit"
                                                        object:nil
                                                      userInfo:nil];
}

- (void) noBtnClick
{
    [self showYesAndNo:NO];
    self.visible = NO;
}

- (void) showYesAndNo:(BOOL) boolflag
{
    continueBtn.isEnabled = !boolflag;
    saveBtn.isEnabled = !boolflag;
    settingBtn.isEnabled = !boolflag;
    exitBtn.isEnabled = !boolflag;
    
    yesBtn.visible = boolflag;
    noBtn.visible = boolflag;
}

- (void) dealloc
{
//    [[CCDirector sharedDirector].touchDispatcher removeDelegate:self];
    [super dealloc];
}
@end
