//
//  SBMenuScene.m
//  SBGame
//
//  Created by Xiaoxuan Tang on 12-11-22.
//
//
#import "SBGlobal.h"
#import "SBMenuScene.h"
#import "SBOptionScene.h"
#import "SimpleAudioEngine.h"
#import "SBGameSelectScene.h"
#import "SBBackGroundScene.h"
#import "SBGameScene.h"
@implementation SBMenuScene

- (void) startGame:(CCNode*) sender
{
    [sender runAction:[CCSequence actionOne:[CCScaleBy actionWithDuration:.1 scale:1.1]
                                        two:[CCCallBlockN actionWithBlock:^(CCNode *node)
    {
        [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:.3 scene:[SBBackGroundScene node]]];
    }]]];
}

- (void) option:(CCNode*) sender
{
}

- (void) loadGame:(CCNode*) sender
{
    SBGameScene* scene = [[SBGameScene alloc] initWithLevel:1];
    [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:.5f
                                                                                 scene:scene]];
    [scene release];
}

-  (id) init
{
    if (self = [super init] )
    {
        if (![[SimpleAudioEngine sharedEngine] isBackgroundMusicPlaying])
        {
            [[SimpleAudioEngine sharedEngine] playBackgroundMusic:@"bgm.mp3" loop:YES];
            [SBGlobal sharedGlobal].bgmName = @"bgm.mp3";
        }
        else
            if (![[SBGlobal sharedGlobal].bgmName isEqualToString:@"bgm.mp3"])
            {
                [[SimpleAudioEngine sharedEngine] playBackgroundMusic:@"bgm.mp3" loop:YES];
                [SBGlobal sharedGlobal].bgmName = @"bgm.mp3";
            }
        
        
        CGSize winSize = [CCDirector sharedDirector].winSize;
        if (winSize.height > winSize.width)
        {
            CGFloat tmp = winSize.width;
            winSize.width = winSize.height;
            winSize.height = tmp;
        }
        
        CCSprite* backGround = [CCSprite spriteWithFile:@"menuBackGround.png"];
        backGround.scaleX = winSize.width/backGround.boundingBox.size.width;
        backGround.scaleY = winSize.height / backGround.boundingBox.size.height;
        backGround.position = ccp(0, 0);
        backGround.anchorPoint = ccp(0, 0);
        [self addChild:backGround];
        
        [CCMenuItemFont setFontSize:150];
        CCMenuItemFont* startLabel = [CCMenuItemImage itemWithNormalImage:@"newGame.png"
                                                            selectedImage:@"newGame1.png"
                                                                   target:self
                                                                 selector:@selector(startGame:)];
        startLabel.position = ccp(630, 380);
        startLabel.anchorPoint = ccp(0, 1);
        
        CCMenuItemFont* loadLabel = [CCMenuItemImage itemWithNormalImage:@"continue.png"
                                                           selectedImage:@"continue1.png"
                                                                  target:self
                                                                selector:@selector(loadGame:)];
        loadLabel.position = ccp(630, 240);
        loadLabel.anchorPoint = ccp(0, 1);
        loadLabel.color = ccGRAY;
        CCMenuItemFont* optionLabel = [CCMenuItemImage itemWithNormalImage:@"system.png"
                                                             selectedImage:@"setting1.png"
                                                                    target:self
                                                                  selector:@selector(option:)];
        optionLabel.position = ccp(630, 120);
        optionLabel.anchorPoint = ccp(0, 1);
        
        CCMenu* menu = [CCMenu menuWithItems:startLabel, loadLabel, optionLabel, nil];
        menu.position = ccp(0, 0);
        menu.anchorPoint = ccp(0, 0);
        [self addChild:menu];
    }
    return self;
}
@end
