//
//  SBOptionScene.m
//  SBGame
//
//  Created by Xiaoxuan Tang on 12-11-22.
//
//

#import "SBOptionScene.h"
#import "cocos2d.h"
#import "CCSlider.h"
#import "SBMenuScene.h"
#import "SBGlobal.h"
@implementation SBOptionScene


- (id) init
{
    if ( self = [super init])
    {
        CGSize winSize = [CCDirector sharedDirector].winSize;
        if (winSize.height > winSize.width)
        {
            CGFloat tmp = winSize.width;
            winSize.width = winSize.height;
            winSize.height = tmp;
        }
        
        CCSprite* backGround = [CCSprite spriteWithFile:@"62-1.png"];
        backGround.scaleX = winSize.width/backGround.boundingBox.size.width;
        backGround.scaleY = winSize.height / backGround.boundingBox.size.height;
        backGround.position = ccp(0, 0);
        backGround.anchorPoint = ccp(0, 0);
        [self addChild:backGround];
        
        CCMenuItemImage *Point1 = [CCMenuItemImage itemWithNormalImage:@"system_sbutton.png" selectedImage:@"system_sbutton.png"];
        CCSprite *Stick1 = [CCSprite spriteWithFile:@"slider.png"];
        Slider1 = [[CCSlider alloc] initWithBackgroundSprite:Stick1 thumbMenuItem:Point1];
        Point1.scaleY = 3;
        CCSprite* bgm = [CCSprite spriteWithFile:@"bgm.png"];
        bgm.scale = .8f;
        bgm.position = ccp(180, 600);
        [self addChild:bgm];
        
        Slider1.value = [SBGlobal sharedGlobal].bgmVolume;
        Slider1.position = ccp(300, 550);
        Slider1.anchorPoint = ccp(0, 0);
        [Slider1 addObserver:self forKeyPath:@"value" options: NSKeyValueObservingOptionNew | NSKeyValueObservingOptionOld context:nil];
        Slider1.tag = 1;
        [self addChild:Slider1];
        [Slider1 release];
        
        CCSprite *effect = [CCSprite spriteWithFile:@"effect.png"];
        effect.scale = .8f;
        effect.position = ccp(180, 450);
        [self addChild:effect];
        
        
        Point1 = [CCMenuItemImage itemWithNormalImage:@"system_sbutton.png" selectedImage:@"system_sbutton.png"];
        Stick1 = [CCSprite spriteWithFile:@"slider.png"];
        
        Slider2 = [[CCSlider alloc] initWithBackgroundSprite:Stick1 thumbMenuItem:Point1];
        Slider2.position = ccp(300, 430);
        Slider2.anchorPoint = ccp(0, 0);
        Point1.scaleY = 3;
        Slider2.value = [SBGlobal sharedGlobal].effectVolume;
        Slider2.tag = 2;
        [self addChild: Slider2];
        [Slider2 addObserver:self forKeyPath:@"value" options:NSKeyValueObservingOptionNew | NSKeyValueObservingOptionOld  context:nil];
        [Slider2 release];
        
        [CCMenuItemFont setFontSize:40];
        
        CCMenuItemImage* erase = [CCMenuItemImage itemWithNormalImage:@"erase.png" selectedImage:@"erase.png" target:nil selector:nil];
        erase.position = ccp(winSize.width/2, 250);
        erase.scale = .8f;
        
        
        
        CCMenuItemImage* back = [CCMenuItemImage itemWithNormalImage:@"back.png" selectedImage:@"back.png" block:^(id sender) {
            
            [sender runAction:[CCSequence actionOne:[CCScaleBy actionWithDuration:.1 scale:1.1]
                                                two:[CCCallBlockN actionWithBlock:^(CCNode *node)
            {
                [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:.3 scene:[SBMenuScene node]]];
            }]]];
        }];
        back.scale = .8;
        back.position = ccp(winSize.width/2, 100);
        back.anchorPoint = ccp(.5, .5);
        CCMenu* menu = [CCMenu menuWithItems:erase, back, nil];
        menu.position = ccp(0, 0);
        [self addChild:menu];
    }
    
    
    return self;
}

- (void) observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
    if ([object isKindOfClass:[CCSlider class]])
    {
        if (((CCSlider*) object).tag == 1)
        {
            [SBGlobal sharedGlobal].bgmVolume = [change[@"new"] floatValue];
        }
        
        if (((CCSlider*)object).tag == 2)
        {
            [SBGlobal sharedGlobal].effectVolume = [change[@"new"] floatValue];
        }
    }
}

- (void) dealloc
{
    [Slider1 removeObserver:self forKeyPath:@"value"];
    [Slider2 removeObserver:self forKeyPath:@"value"];
    [super dealloc];
}
@end
