//
//  SBTestAnimation.m
//  SBGame
//
//  Created by Xiaoxuan Tang on 12-12-31.
//
//

#import "SBTestAnimation.h"

@implementation SBTestAnimation

- (id) init
{
    if ( self = [super init] )
    {
        [[CCSpriteFrameCache sharedSpriteFrameCache] addSpriteFramesWithFile:@"SBImage.plist"];
        CCAnimation* animation = [CCAnimation animation];
        animation.delayPerUnit = .25;
        for (int i=1; i<4; i++) {
            CCSpriteFrame* frame = [[CCSpriteFrameCache sharedSpriteFrameCache]
                                    spriteFrameByName:[NSString stringWithFormat:@"major_walk_%d.png", i]];
            [animation addSpriteFrame: frame];
        }
        
        CCSprite* sprite = [CCSprite spriteWithSpriteFrameName:@"major_walk_1.png"];
        sprite.position = ccp(200, 200);
        CCAnimate *animate = [CCAnimate actionWithAnimation:animation];
        CCRepeatForever* repeat = [CCRepeatForever actionWithAction:animate];
        [sprite runAction:repeat];
        sprite.tag = 1;
        [self addChild:sprite];
        
        [self schedule:@selector(run) interval:.1];
    }
    return self;
}

- (void) run
{
    CCNode* node = [self getChildByTag:1];
    node.position = ccpAdd(node.position, ccp(3, 0));
}

@end
